main(){
	maps\mp\_load::main();
	
	//meee laazzyyy - fx =============================================================
	level._effect["snow_light"]	= loadfx ("fx/misc/snow_light_mp_railyard.efx");
	level._effect["thin_light_smoke_M"]	= loadfx("fx/smoke/thin_light_smoke_M.efx"); 
	level._effect["thin_black_smoke_M"]	= loadfx ("fx/smoke/thin_black_smoke_M.efx");  
	level._effect["fogbank_small_duhoc"] = loadfx ("fx/misc/fogbank_small_duhoc.efx");  
	level._effect["steam"] = loadfx ("fx/winterv2/steam.efx");  
	level._effect["flak_explosion"]	= loadfx("fx/explosions/flak88_explosion.efx");
	level._effect["bombexplosion"] = loadfx("fx/props/barrelexp.efx");
	//custom flak - fx
	level.flak_light = loadfx("fx/chelm/flak_light.efx"); 
	level.scr_sound["building_explosion1"] = "building_explosion1";
	level.scr_sound["flak_fire"] = "flak_fire";
	level.scr_sound["flak_stop"] = "flak_stop";
	level.scr_sound["flak_reloading"] = "flak_reloading";
	//meee more lazyyyyy - soundfx
	level.scr_sound["flak88_explode"] = "flak88_explode";
	level.scr_sound["dooropen"] = "dooropen";
	level.scr_sound["doorclosed"] = "doorclosed";
	level.scr_sound["doormoving"] = "doormoving";
	//================================================================================
	
	setExpFog(0.00015, 0.8, 0.8, 0.8, 0);
	ambientPlay("ambient_winterv2_ext");
	
	//snow
	maps\mp\_fx::loopfx("snow_light", (-2000,900,355), 0.3, (-2000,900,455));
	
	game["allies"] = "russian";
	game["axis"] = "german";
	game["attackers"] = "allies";
	game["defenders"] = "axis";
	game["russian_soldiertype"] = "coats";
	game["german_soldiertype"] = "winterlight";
	
	setcvar("r_glowbloomintensity0","1");
	setcvar("r_glowbloomintensity1","1");
	setcvar("r_glowskybleedintensity0",".5");
	
	level.door_open = 0;
	//level functions and shtuff
	level thread doHQ();
	level thread doBunkerwin();
	level thread doFX();
	level thread doDoor();
	level thread maps\mp\ora_flak::main();
}
//using script_origins in map "radio" as targetnames for the locations of HQ
doHQ(){
	if(getcvar("g_gametype") == "hq"){
		level.radio = [];
		radioloc = getentarray("radio", "targetname");
		logPrint("Number of radios: " + radioloc.size + "\n");
		println("Number of radios:: " + radioloc.size + "\n");
		for(i=0; i<radioloc.size; i++){
			level.radio[i] = spawn("script_model", (radioloc[i].origin));
			level.radio[i].angles = (radioloc[i].angles);
			logPrint("Radio " + i + " set at (" + radioloc[i].origin + "), angles of (" + radioloc[i].angles + ") \n");
			println("Radio " + i + " set at (" + radioloc[i].origin + "), angles of (" + radioloc[i].angles + ") \n");
		}
	}
}
//add smokey/foggy to map
doFX(){
	smokeorigin = getentarray("smoke", "targetname");
	smoke2origin = getentarray("smoke2", "targetname");
	steam = getentarray("steam", "targetname");
	steam_simple = getentarray("steam_simple", "targetname");
		
	//crater smoke
	for(q=0; q<smokeorigin.size; q++){
		maps\mp\_fx::loopfx("thin_light_smoke_M", (smokeorigin[q].origin), 1, (smokeorigin[q].origin+(100,0,0)));
	}
	//black smoke out of tanks
	for(q=0; q<smoke2origin.size; q++){
		maps\mp\_fx::loopfx("thin_black_smoke_M", (smoke2origin[q].origin), 1, (smoke2origin[q].origin+(100,0,0)));
	}
	//pipe steam and fog
	for(q=0; q<steam.size; q++){
		maps\mp\_fx::loopfx("steam", (steam[q].origin), 0.1, (steam[q].origin+(100,0,0)));
		maps\mp\_fx::loopfx("fogbank_small_duhoc", (steam[q].origin), 2, (steam[q].origin+(100,0,0)));
	}
	for(q=0; q<steam_simple.size; q++){
		maps\mp\_fx::loopfx("steam", (steam_simple[q].origin), 2, (steam_simple[q].origin+(100,0,0)));
	}
}
//script to control the bunker door
doDoor(){
	door_trig = getent("door_trig", "targetname");
	door = getent("door", "targetname");
	handle = getent("handle", "targetname");
	handle_gear = getent("handle_gear", "targetname");
	door_sound = getent("door_sound", "targetname");
	//preset to open
	while(1){
		if(level.door_open == 1)
			door_trig waittill("trigger");
		level.door_open = 1;
		handle rotateto((-270, 0, 0), 2, 0.5, 0.5);
		handle_gear movez(19, 2, 0.5, 0.5);	
		wait 2;
		door movey(-6, 0.2, 0, 0);
		door_sound playSound("dooropen");	
		wait 1.5;
		door movey(-108, 6, 1, 1); 
		door_sound playSound("doormoving");	
		wait 6;
		door_sound playSound("doorclosed");	
		wait 3;
		door_trig waittill("trigger");
		door movey(6, 0.2, 0, 0);
		door_sound playSound("dooropen");	
		wait 1.5;
		door movey(108, 6, 1, 1);
		door_sound playSound("doormoving");	
		wait 6;
		door_sound playSound("doorclosed");	
		handle rotateto((270, 0, 0), 2, 0.5, 0.5);
		handle_gear movez(-19, 2, 0.5, 0.5);
		wait 5;
	}
}
//script to control the window shields of the bunkers
doBunkerwin(){
	trigs = getentarray("trigs", "targetname");
	for(j=0; j<trigs.size; j++){
		trig = trigs[j];
		thread Bunker_Think(trig);
	}
}
Bunker_Think(trig){
	switcher = getent(trig.target, "targetname");
	win = getent(switcher.target, "targetname");
	while(1){
		//iprintln("in loop");
		trig waittill("trigger");
		//iprintln("switch on\n");
		switcher.angles += (180,0,0);
		win movez(19, 1,0.1,0.1);
		switcher playSound("doorclosed");	
		win waittill("movedone");
		wait 2;
		trig waittill("trigger");
		//iprintln("switch off\n");
		switcher.angles += (180,0,0);
		win movez(-19, 1,0.1,0.1);
		switcher playSound("dooropen");	
		win waittill("movedone");
		wait 2;
	}
}